

-- The Gnomish Yellow Pages
-- let your stumpy little fingers do the walking

local MAJOR_VERSION = "0.1"
local MINOR_VERSION = ("$Revision: 10 $"):match("%d+")

local faction = UnitFactionGroup("player")
local realmName = GetRealmName()

local serverKey = realmName.."-"..faction
local player = UnitName("player")





do
	local ScrollingTable = {}
	
	
-- i'm using am modified version of the scrolling table library until things get squared away a bit more
-- BEGIN CUSTOM SCROLLING TABLE FUNCTION
	do 
		local defaultcolor = { ["r"] = 1.0, ["g"] = 1.0, ["b"] = 1.0, ["a"] = 1.0 };
		local defaulthighlight = { ["r"] = 1.0, ["g"] = 0.9, ["b"] = 0.0, ["a"] = 0.5 };
		local defaulthighlightblank = { ["r"] = 0.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 };
		local lrpadding = 2.5;
		
		local ScrollPaneBackdrop  = {
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 3, right = 3, top = 5, bottom = 3 }
		};
		
		local framecount = 1; 
		
		local SetHeight = function(self)
			self.frame:SetHeight( (self.displayRows * self.rowHeight) + 10);
			self:Refresh();
		end
		
		local SetWidth = function(self)
			local width = 13;
			for num, col in pairs(self.cols) do
				width = width + col.width;
			end
			self.frame:SetWidth(width+20);
			self:Refresh();
		end
		
		local SetHighLightColor = function(frame, color)
			if not frame.highlight then 
				frame.highlight = frame:CreateTexture(nil, "OVERLAY");
				frame.highlight:SetAllPoints(frame);
			end
			frame.highlight:SetTexture(color.r, color.g, color.b, color.a);
		end
		
		local SetBackgroundColor = function(frame, color)
			if not frame.background then 
				frame.background = frame:CreateTexture(nil, "BACKGROUND");
				frame.background:SetAllPoints(frame);
			end
			frame.background:SetTexture(color.r, color.g, color.b, color.a);
		end

		
		local RegisterEvents = function(self, events, fRemoveOldEvents) 
			local table = self; -- save for closure later
			
			for i, row in ipairs(self.rows) do 
				for j, col in ipairs(row.cols) do
					-- unregister old events.
					if fRemoveOldEvents and self.events then 
						for event, handler in pairs(self.events) do 
							col:SetScript(event, nil);
						end
					end
					
					-- register new ones.
					for event, handler in pairs(events) do 
						col:SetScript(event, function(cellFrame, ...)
							local realindex = table.filtered[i+table.offset];
							handler(row, cellFrame, table.data, table.cols, i, realindex, j, ...);
						end);
					end
				end
			end
			self.events = events;
		end
		
		local SetDisplayRows = function(self, num, rowHeight)
			-- should always set columns first
			self.displayRows = num;
			self.rowHeight = rowHeight;
			if not self.rows then 
				self.rows = {};
			end
			for i = 1, num do 
				local row = self.rows[i];
				if not row then 
					row = CreateFrame("Button", self.frame:GetName().."Row"..i, self.frame);
					row.SetHighLightColor = SetHighLightColor;
					
					self.rows[i] = row;
					if i > 1 then 
						row:SetPoint("TOPLEFT", self.rows[i-1], "BOTTOMLEFT", 0, 0);
						row:SetPoint("TOPRIGHT", self.rows[i-1], "BOTTOMRIGHT", 0, 0);
					else
						row:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 4, -5);
						row:SetPoint("TOPRIGHT", self.frame, "TOPRIGHT", -4, -5);
					end
					row:SetHeight(rowHeight);
				end
				
				if not row.cols then 
					row.cols = {};
				end
				for j = 1, #self.cols do
					local col = row.cols[j];
					if not col then 
						col = CreateFrame("Button", row:GetName().."col"..j, row);
						col.text = row:CreateFontString(col:GetName().."text", "OVERLAY", "GameFontHighlightSmall");
						row.cols[j] = col;
						local align = self.cols[j].align or "LEFT";
						col.text:SetJustifyH(align);
						
						if self.events then
							for event, handler in pairs(self.events) do 
								col:SetScript(event, function(cellFrame, ...)
									local realindex = self.filtered[i+table.offset];
									handler(row, cellFrame, self.data, self.cols, i, realindex, j, ...);
								end);
							end
						end
					end
					col:EnableMouse(true);
					col:RegisterForClicks("AnyUp");
					
					if j > 1 then 
						col:SetPoint("LEFT", row.cols[j-1], "RIGHT", 0, 0);
					else
						col:SetPoint("LEFT", row, "LEFT", 2, 0);
					end
					col:SetHeight(rowHeight);
					col:SetWidth(self.cols[j].width);
					col.text:SetPoint("TOP", col, "TOP", 0, 0);
					col.text:SetPoint("BOTTOM", col, "BOTTOM", 0, 0);
					col.text:SetWidth(self.cols[j].width - 2*lrpadding);
				end
				j = #self.cols + 1;
				col = row.cols[j];
				while col do
					col:Hide();
					j = j + 1;
					col = row.cols[j];
				end
			end
			
			for i=num+1,#self.rows do
				self.rows[i]:Hide()
			end
			
			self:SetHeight();
		end
		
		local SetDisplayCols = function(self, cols)
			local table = self; -- reference saved for closure
			self.cols = cols;
			
			local rowFrameName = self.frame:GetName().."Head";
			local row = getglobal(rowFrameName);
			if not row then 
				row = CreateFrame("Frame", rowFrameName, self.frame);
				row:SetPoint("BOTTOMLEFT", self.frame, "TOPLEFT", 4, 0);
				row:SetPoint("BOTTOMRIGHT", self.frame, "TOPRIGHT", -4, 0);
				row:SetHeight(self.rowHeight);
				row.cols = {};
			end
			for i = 1, #cols do 
				local colFrameName =  row:GetName().."Col"..i;
				local col = row.cols[i]
				
				if not col then
					col = CreateFrame("Button", colFrameName, row);			
					col:SetScript("OnClick", function (self, button)
						if button == "LeftButton" then
							for j = 1, #table.cols do 
								if j ~= i then -- clear out all other sort marks
									table.cols[j].sort = nil;
								end
							end
							local sortorder = "asc";
							if not table.cols[i].sort and table.cols[i].defaultsort then
								sortorder = table.cols[i].defaultsort; -- sort by columns default sort first;
							elseif table.cols[i].sort and table.cols[i].sort:lower() == "asc" then 
								sortorder = "dsc";
							end
							table.cols[i].sort = sortorder;
							table:SortData();
						else
							if table.cols[i].rightclick then
								table.cols[i].rightclick();
							end
						end
					end);
					
					
					col:SetScript("OnEnter", function (frame)
						if table.cols[i].tooltipText then
							GameTooltip:SetOwner(frame, "ANCHOR_TOPLEFT")
			
							GameTooltip:ClearLines()

							GameTooltip:AddLine(table.cols[i].tooltipText,1,1,1)
						
							GameTooltip:Show()
						end
					end);
					
					col:SetScript("OnLeave", function (self)
						GameTooltip:Hide()
					end);
							
					col:RegisterForClicks("AnyUp");
					row.cols[i] = col;
				end
				
				
				local fs = col:GetFontString() or col:CreateFontString(col:GetName().."fs", "OVERLAY", "GameFontHighlightSmall");
				fs:SetAllPoints(col);
				fs:SetPoint("LEFT", col, "LEFT", lrpadding, 0);
				fs:SetPoint("RIGHT", col, "RIGHT", -lrpadding, 0);
				local align = cols[i].align or "LEFT";
				fs:SetJustifyH(align); 
				
				col:SetFontString(fs);
				fs:SetText(cols[i].name);
				fs:SetTextColor(1.0, 1.0, 1.0, 1.0);
				col:SetPushedTextOffset(0,0);
				
				if i > 1 then 
					col:SetPoint("LEFT", row.cols[i-1], "RIGHT", 0, 0);
				else
					col:SetPoint("LEFT", row, "LEFT", 2, 0);
				end
				col:SetHeight(self.rowHeight);
				col:SetWidth(cols[i].width);
				
				local color = cols[i].bgcolor;
				if (color) then 
					local colibg = "col"..i.."bg";
					local bg = self.frame[colibg]; 
					if not bg then 
						bg = self.frame:CreateTexture(nil, "OVERLAY");
						self.frame[colibg] = bg;
					end 
					bg:SetPoint("BOTTOM", self.frame, "BOTTOM", 0, 4);
					bg:SetPoint("TOPLEFT", col, "BOTTOMLEFT", 0, -4);
					bg:SetPoint("TOPRIGHT", col, "BOTTOMRIGHT", 0, -4);
					bg:SetTexture(color.r, color.g, color.b, color.a);
				end
			end
			
			self:SetWidth();
		end
		
		local Show = function(self)
			self.frame:Show();
			self.scrollframe:Show();
			self.showing = true;
		end
		local Hide = function(self)
			self.frame:Hide();
			self.showing = false;
		end
		
		local SetData = function(self, data)
			self.data = data;
			self:SortData();
		end
			
		local SortData = function(self)
			-- sanity check
			if not(self.sorttable) or (#self.sorttable > #self.data)then 
				self.sorttable = {};
			end
			if #self.sorttable ~= #self.data then
				for i = 1, #self.data do 
					self.sorttable[i] = i;
				end
			end 
			
			-- go on sorting
			local i, sortby = 1, nil;
			while i <= #self.cols and not sortby do
				if self.cols[i].sort then 
					sortby = i;
				end
				i = i + 1;
			end
			if sortby then 
				table.sort(self.sorttable, function(a,b)
					local cella, cellb = self.data[a], self.data[b];
					local column = self.cols[sortby];
					if column.comparesort then 
						return column.comparesort(cella, cellb, sortby, 0);
					else
						return self:CompareSort(cella, cellb, sortby, 0);
					end
				end);
			end
			self.filtered = self:DoFilter();
			self:Refresh();
		end
		
		local StringToNumber = function(str)
			if str == "" then 
				return 0;
			else
				return tonumber(str)
			end
		end
		
		local CompareSort = function (self, cella, cellb, sortby, depth)
			if depth > 10 then return true end
			
			local a1, b1 = cella.cols[sortby].value, cellb.cols[sortby].value;
			local column = self.cols[sortby]
			
			if type(a1) == "function" then 
				a1 = a1(unpack(cella.args or {}));
			end
			if type(b1) == "function" then 
				b1 = b1(unpack(cellb.args or {}));
			end
			
			if type(a1) ~= type(b1) then
				local typea, typeb = type(a1), type(b1);
				if typea == "number" and typeb == "string" then 
					if tonumber(typeb) then -- is it a number in a string?
						b1 = StringToNumber(b1); -- "" = 0
					else
						a1 = tostring(a1);
					end
				elseif typea == "string" and typeb == "number" then 
					if tonumber(typea) then -- is it a number in a string?
						a1 = StringToNumber(a1); -- "" = 0
					else
						b1 = tostring(b1);
					end
				end
			end
			
			if a1 == b1 and column.sortnext then
				sortby = column.sortnext
				
				if column.comparesort then 
					return column.comparesort(cella, cellb, column.sortnext, depth+1);
				else
					return self:CompareSort(cella, cellb, column.sortnext, depth+1);
				end
			else
				local direction = column.sort or column.defaultsort or "asc";
				if direction:lower() == "asc" then 		
					return a1 > b1;
				else
					return a1 < b1;
				end
			end
		end
		
		local Filter = function(self, ...)
			return true;
		end
		
		local SetFilter = function(self, Filter)
			self.Filter = Filter;
			self:SortData();
		end
		
		local DoFilter = function(self)
			local result = {};
			for row = 1, #self.data do 
				if self:Filter(self.data[self.sorttable[row]]) then
					table.insert(result, self.sorttable[row]);
				end
			end
			return result;
		end
		
		local DoCellUpdate = function(rowFrame, cellFrame, data, cols, row, realrow, column, fShow, ...)
			if fShow then
				local cellData = data[realrow].cols[column];
				
				if type(cellData.value) == "function" then 
					cellFrame.text:SetText(cellData.value(unpack(cellData.args or {})) );
				else
					cellFrame.text:SetText(cellData.value);
				end
				
				local color = cellData.color;
				local colorargs = nil;
				if not color then 
					color = cols[column].color;
					if not color then 
						color = data[realrow].color;
						if not color then 
							color = defaultcolor;
						else
							colorargs = data[realrow].colorargs;
						end
					else
						colorargs = cols[column].colorargs;
					end
				else
					colorargs = cellData.colorargs;
				end	
				if type(color) == "function" then 
					color = color(unpack(colorargs or {cellFrame}));
				end
				cellFrame.text:SetTextColor(color.r, color.g, color.b, color.a);
			else
				cellFrame.text:SetText("");
			end
		end
		
		function ScrollingTable:CreateST(cols, numRows, rowHeight, highlight, parent)
			local st = {};
			local f = CreateFrame("Frame", "ScrollTable"..framecount, parent or UIParent);
			framecount = framecount + 1;
			st.showing = true;
			st.frame = f;
			
			st.Show = Show;
			st.Hide = Hide;
			st.SetDisplayRows = SetDisplayRows;
			st.SetRowHeight = SetRowHeight;
			st.SetHeight = SetHeight;
			st.SetWidth = SetWidth;
			st.SetDisplayCols = SetDisplayCols;
			st.SetData = SetData;
			st.SortData = SortData;
			st.CompareSort = CompareSort;
			st.RegisterEvents = RegisterEvents;
			
			st.SetFilter = SetFilter;
			st.DoFilter = DoFilter;
			
			st.highlight = highlight or defaulthighlight;
			st.displayRows = numRows or 12;
			st.rowHeight = rowHeight or 15;
			st.cols = cols or {
				{
					["name"] = "Test 1",
					["width"] = 50,
					["color"] = { ["r"] = 0.5, ["g"] = 0.5, ["b"] = 1.0, ["a"] = 1.0 },
				}, -- [1]
				{ 
					["name"] = "Test 2", 
					["width"] = 50, 
					["align"] = "CENTER",
					["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.2 },
				}, -- [2]
				{ 
					["name"] = "Test 3", 
					["width"] = 50, 
					["align"] = "RIGHT",
					["bgcolor"] = { ["r"] = 0.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.5 },
				}, -- [3]
			};
			st.data = {};
			st.offset = 0;
		
			f:SetBackdrop(ScrollPaneBackdrop);
			f:SetBackdropColor(0.1,0.1,0.1);
			f:SetPoint("CENTER",UIParent,"CENTER",0,0);
			
			-- build scroll frame		
			local scrollframe = CreateFrame("ScrollFrame", f:GetName().."ScrollFrame", f, "FauxScrollFrameTemplate");
			st.scrollframe = scrollframe;
			scrollframe:Show();
--			scrollframe:SetScript("OnHide", function(self, ...)
--				self:Show();
--			end);
			scrollframe:SetPoint("TOPLEFT", f, "TOPLEFT", 0, -4);
			scrollframe:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -26, 3);
			
			local scrolltrough = CreateFrame("Frame", f:GetName().."ScrollTrough", scrollframe);
			scrolltrough:SetWidth(17);
			scrolltrough:SetPoint("TOPRIGHT", f, "TOPRIGHT", -4, -3);
			scrolltrough:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -4, 4);
			scrolltrough.background = scrolltrough:CreateTexture(nil, "BACKGROUND");
			scrolltrough.background:SetAllPoints(scrolltrough);
			scrolltrough.background:SetTexture(0.05, 0.05, 0.05, 1.0);
			local scrolltroughborder = CreateFrame("Frame", f:GetName().."ScrollTroughBorder", scrollframe);
			scrolltroughborder:SetWidth(1);
			scrolltroughborder:SetPoint("TOPRIGHT", scrolltrough, "TOPLEFT");
			scrolltroughborder:SetPoint("BOTTOMRIGHT", scrolltrough, "BOTTOMLEFT");
			scrolltroughborder.background = scrolltrough:CreateTexture(nil, "BACKGROUND");
			scrolltroughborder.background:SetAllPoints(scrolltroughborder);
			scrolltroughborder.background:SetTexture(0.5, 0.5, 0.5, 1.0);
			
			st.Refresh = function(self)	
				FauxScrollFrame_Update(scrollframe, #st.filtered, st.displayRows, st.rowHeight);
				local o = FauxScrollFrame_GetOffset(scrollframe);
				st.offset = o;
				
				for i = 1, st.displayRows do
					local row = i + o;	
					if st.rows then
						for col = 1, #st.cols do
							local rowFrame = st.rows[i];
							local cellFrame = rowFrame.cols[col];
							local fShow = true;
							local fnDoCellUpdate = DoCellUpdate;
							if st.data[st.filtered[row]] then
								st.rows[i]:Show();
								local rowData = st.data[st.filtered[row]];
								local cellData = rowData.cols[col];
								if cellData.DoCellUpdate then 
									fnDoCellUpdate = cellData.DoCellUpdate;
								elseif st.cols[col].DoCellUpdate then 
									fnDoCellUpdate = st.cols[col].DoCellUpdate;
								elseif rowData.DoCellUpdate then
									fnDoCellUpdate = rowData.DoCellUpdate;
								end
							else
								st.rows[i]:Hide();
								fShow = false;
							end
							fnDoCellUpdate(rowFrame, cellFrame, st.data, st.cols, row, st.filtered[row], col, fShow);
						end
					end
				end
			end
			
			scrollframe:SetScript("OnVerticalScroll", function(self, offset)
				FauxScrollFrame_OnVerticalScroll(self, offset, st.rowHeight, st.Refresh);
			end);
		
			st:SetFilter(Filter);
			st:SetDisplayCols(st.cols);
			st:SetDisplayRows(st.displayRows, st.rowHeight);
			st:RegisterEvents({
				["OnEnter"] = function (rowFrame, ...)
					SetHighLightColor(rowFrame, st.highlight);
				end, 
				["OnLeave"] = function(rowFrame, ...)
					SetHighLightColor(rowFrame, defaulthighlightblank);
				end,
			});
			
			return st;
		end
	end
-- END CUSTOM SCROLLING TABLE FUNCTION

	local st
	
	local tradeIDbyName = {}
	local libTLIDbyTradeID = {}
	local basicTradeID = {}
	local tradeList = {}
	
	local function buildBasicTradeTable(aliases, libTLID)
		for n=1,#aliases do
			basicTradeID[aliases[n]] = aliases[1]
		end
		
		table.insert(tradeList,{ tradeID = aliases[1]})
		
		tradeIDbyName[GetSpellInfo(aliases[1])] = aliases[1]
		libTLIDbyTradeID[aliases[1]] = libTLID
	end


	
	buildBasicTradeTable({ 2259,3101,3464,11611,28596,28677,28675,28672,51304 }, 171)						-- alchemy
	buildBasicTradeTable({ 2018,3100,3538,9785,9788,9787,17039,17040,17041,29844,51300 }, 164)				-- bs
	buildBasicTradeTable({ 7411,7412,7413,13920,28029,51313 }, 333)											-- enchanting
	buildBasicTradeTable({ 4036,4037,4038,12656,20222,20219,30350,51306 }, 202)								-- eng
	buildBasicTradeTable({ 45357,45358,45359,45360,45361,45363 }, 773)										-- inscription
	buildBasicTradeTable({ 25229,25230,28894,28895,28897,51311 }, 755)										-- jc
	buildBasicTradeTable({ 2108,3104,3811,10656,10660,10658,10662,32549,51302 }, 165)						-- lw
	buildBasicTradeTable({ 3908,3909,3910,12180,26801,26798,26797,26790,51309 }, 197)						-- tailoring
	
	
	buildBasicTradeTable({ 2550,3102,3413,18260,33359,51296 }, 185)											-- cooking
	buildBasicTradeTable({ 3273,3274,7924,10846,27028,45542,10846 }, 129)									-- first aid

--	buildBasicTradeTable({ 2656 })
	
	
	local currentTradeskill = nil
	local currentTradeBitmap = nil

--[[
	tradeskill filter popup stuff:
]]
	local selectedTradeskill = nil
	
	local function TradeFilterToggle(button, slot)
		selectedTradeskill = tradeList[slot].tradeID
		st:SortData()
	end
	
	
	local function TradeFilterAll()
		selectedTradeskill = nil
		st:SortData()
	end

	
	local tradeFilterMenu = {}

	table.insert(tradeFilterMenu, { text = "All Trades", func = TradeFilterAll, fontObject = GameFontNormal})
	
	for i=1,#tradeList do
		table.insert(tradeFilterMenu, { text = GetSpellInfo(tradeList[i].tradeID), func = TradeFilterToggle, arg1 = i, checked = function() return selectedTradeskill == tradeList[i].tradeID end })
	end
	
--[[
	age filter popup stuff:
]]
	local selectedAge = nil
	
	local function AgeFilterSet(button, age)
		selectedAge = age
		st:SortData()
	end
	
	local ageFilterMenu = {
		{ text = "All", func = AgeFilterSet, arg1 = nil,  fontObject = GameFontNormal },
		{ text = "1 day", func = AgeFilterSet, arg1 = 1, checked = function() return selectedAge == 1 end },
		{ text = "1 week", func = AgeFilterSet, arg1 = 7, checked = function() return selectedAge == 7 end},
		{ text = "2 weeks", func = AgeFilterSet, arg1 = 14, checked = function() return selectedAge == 14 end },
		{ text = "1 month", func = AgeFilterSet, arg1 = 30, checked = function() return selectedAge == 30 end },
	}

	
		
--[[
	level filter popup stuff:
]]
	local selectedLevel = nil
	
	local function LevelFilterSet(button, level)
		selectedLevel = level
		st:SortData()
	end
	
	local levelFilterMenu = {
		{ text = "All", func = LevelFilterSet, arg1 = nil,  fontObject = GameFontNormal },
		{ text = "100+", func = LevelFilterSet, arg1 = 100, checked = function() return selectedLevel == 100 end },
		{ text = "200+", func = LevelFilterSet, arg1 = 200, checked = function() return selectedLevel == 200 end},
		{ text = "300+", func = LevelFilterSet, arg1 = 300, checked = function() return selectedLevel == 300 end },
		{ text = "375+", func = LevelFilterSet, arg1 = 375, checked = function() return selectedLevel == 375 end },
		{ text = "450", func = LevelFilterSet, arg1 = 450, checked = function() return selectedLevel == 400 end },
	}


	
--[[
	player filter popup stuff:
]]
	local selectedPlayers = {["STRANGERS"] = true, ["OFFLINE"] = true}
	
	local function PlayerFilterSet(button, setting)
		selectedPlayers[setting] = not selectedPlayers[setting]
		st:SortData()
	end
	
	
	
	local playerFilterMenu = {
		{ text = "Show Strangers", func = PlayerFilterSet, arg1 = "STRANGERS", checked = function() return selectedPlayers["STRANGERS"] end},
		{ text = "Show Offline", func = PlayerFilterSet, arg1 = "OFFLINE", checked = function() return selectedPlayers["OFFLINE"] end },
	}

	
	
	
	
	local whoDataPending = false
	local guildDataPending = false
	
	
	local onlineColorTable = { ["r"] = 0.8, ["g"] = 0.8, ["b"] = 0.8, ["a"] = 1.0 }
	local offlineColorTable = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 1.0 }
	local localColorTable = { ["r"] = 0.4, ["g"] = 0.8, ["b"] = 1.0, ["a"] = 1.0 }
	local friendColorTable = { ["r"] = 1.0, ["g"] = 0.8, ["b"] = 0.4, ["a"] = 1.0 }
	local guildColorTable = { ["r"] = 0.2, ["g"] = 1.0, ["b"] = 0.2, ["a"] = 1.0 }
	
	local singleSharedColorTable = 	{ ["r"] = 0.5, ["g"] = 1.0, ["b"] = 1.0, ["a"] = 1.0 }
	local sharedColorTable = 		{ ["r"] = 1.0, ["g"] = 1.0, ["b"] = 0.0, ["a"] = 1.0 }
	local noneSharedColorTable = 	{ ["r"] = 0.5, ["g"] = 0.5, ["b"] = 0.0, ["a"] = 1.0 }


	local playerList = {}
	local playerLocation = {}
	local timerList = {}
	local friendList = {}
	local guildList = {}
	local guildCraftList = {}
	local playerAge = {}
	local playerWhoPending = ""
	
	local frame
	local whoAutoUpdateToggle
	local whoAutoUpdateFrequency
		
	local OFFLINE = "** Offline **"
	local ONLINE = "Online"
	
	local colorWhite = { ["r"] = 1.0, ["g"] = 1.0, ["b"] = 1.0, ["a"] = 1.0 }
	local colorBlack = { ["r"] = 0.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 1.0 }
	local colorDark = { ["r"] = 0.1, ["g"] = 0.1, ["b"] = 0.1, ["a"] = 1.0 }
	
	local highlightOff = { ["r"] = 0.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }
	
	
	local scrollBarOffset = 0
	
	if not YPFilterMenuFrame then
		YPFilterMenuFrame = CreateFrame("Frame", "YPFilterMenuFrame", getglobal("UIParent"), "UIDropDownMenuTemplate")
	end
	
	local TradeLink = {}
	
	function TradeLink:BitmapCompress(bitmap)
		local len = string.len(bitmap)
		local compressed = {}
		local n = 1
		
		for i=1,len,5 do
			local map = 0
			
			v = string.byte(bitmap, i) or 60
			map = v - 60
			
			v = string.byte(bitmap,i+1) or 60
			map = bit.lshift(map, 6) + v - 60

			
			v = string.byte(bitmap,i+2) or 60
			map = bit.lshift(map, 6) + v - 60

			
			v = string.byte(bitmap,i+3) or 60
			map = bit.lshift(map, 6) + v - 60

			
			v = string.byte(bitmap,i+4) or 60
			map = bit.lshift(map, 6) + v - 60
			
			compressed[n] = map
			
			n = n + 1
		end
		
		return compressed
	end
	
	
	function TradeLink:BitsShared(b1, b2)
		local sharedBits = 0
		local len = math.min(#b1,#b2)
		
		for i=1,len do
			result = bit.band(b1[i],b2[i] or 0)
--DEFAULT_CHAT_FRAME:AddMessage(tostring(b1[i]).." "..tostring(b2[i]).." result "..result)

			if result~=0 then
				for b=0,29 do
					if bit.band(result, 2^b)~=0 then
						sharedBits = sharedBits + 1
					end
				end
			end
		end
--DEFAULT_CHAT_FRAME:AddMessage("shared "..sharedBits)		
		return sharedBits
	end
	
	
	
	local function SimpleTime(t)
		local mins = t/60
		local hours = mins/60
		local days = hours/24
		
		if days > 2 then
			return (math.floor(days*10)/10).." days"
		end
		
		if mins > 100 then
			return (math.floor(hours*10)/10).." hrs"
		end
		
		return (math.floor(mins)).." mins"
	end
	
	
	
	

	local columnHeaders = {
		{
			["name"] = "player",
			["width"] = 100,
			["bgcolor"] = colorBlack,
			["tooltipText"] = "click to sort\rright-click to filter",
			["onclick"] =	function(button, player)
								local playerString = "player:"..player
								local playerLink = "|Hplayer:"..player.."|h["..player.."]|h"
								
								SetItemRef(playerString,playerLink,button)
							end,
			["rightclick"] = 	function()
									local x, y = GetCursorPosition()
									local uiScale = UIParent:GetEffectiveScale()
									
									EasyMenu(playerFilterMenu, YPFilterMenuFrame, getglobal("UIParent"), x/uiScale,y/uiScale, "MENU", 5)
								end
			
			
		}, -- [1]
		{
			["name"] = "location",
			["width"] = 150,
			["bgcolor"] = colorDark,
			["sortnext"]= 4,
			["tooltipText"] = "click to sort",
			["onclick"] = function(button, player)
								whoDataPending = true
								SetWhoToUI(1)
								SendWho(player)
							end
		}, -- [2]
		{ 
			["name"] = "level", 
			["width"] = 40, 
			["align"] = "CENTER",
			["bgcolor"] = colorBlack,
			["tooltipText"] = "click to sort\rright-click to filter",
			["sortnext"]= 1,
			["rightclick"] = 	function()
									local x, y = GetCursorPosition()
									local uiScale = UIParent:GetEffectiveScale()
									
									EasyMenu(levelFilterMenu, YPFilterMenuFrame, getglobal("UIParent"), x/uiScale,y/uiScale, "MENU", 5)
								end
		}, -- [3]
		{ 
			["name"] = "trade", 
			["width"] = 100, 
			["align"] = "CENTER",
			["color"] = { ["r"] = 1.0, ["g"] = 1.0, ["b"] = 0.0, ["a"] = 1.0 },
			["bgcolor"] = colorDark,
			["tooltipText"] = "click to sort\rright-click to filter",
			["sortnext"] = 3,
			["onclick"] =	function(button, link)
								local _,_,tradeString = string.find(link, "(trade:%d+:%d+:%d+:[0-9a-fA-F]+:[<-{]+)")

								SetItemRef(tradeString,arg1,button)
							end,
			["rightclick"] = 	function()
									local x, y = GetCursorPosition()
									local uiScale = UIParent:GetEffectiveScale()
									
									EasyMenu(tradeFilterMenu, YPFilterMenuFrame, getglobal("UIParent"), x/uiScale,y/uiScale, "MENU", 5)
								end
			
		}, -- [4]
		{ 
			["name"] = "age", 
			["width"] = 60, 
			["align"] = "CENTER",
			["bgcolor"] = colorBlack,
			["defaultsort"] = "asc",
			["sortnext"]= 4,
			["sort"] = "asc",
			["tooltipText"] = "click to sort\rright-click to filter",
			["DoCellUpdate"] =	function (rowFrame, cellFrame, data, cols, row, realrow, column, fShow, ...)
									if fShow then
										local cellData = data[realrow].cols[column];
										
										local elapsedTime = time() - cellData.value
										local formattedElapsedTime = SimpleTime(elapsedTime)
										
										if formattedElapsedTime == "" then
											formattedElapsedTime = "NEW"
										end

										cellFrame.text:SetText(formattedElapsedTime)
										
										local daysOld = (elapsedTime / (60*60*24))
										local cr = min(1,daysOld*.5+.5)
										local cg = min(1,1-min(math.pow(daysOld,2),1)*.8)
										local cb = max(0,min(1,daysOld*(1-daysOld)))*.8+.2
										
										cellFrame.text:SetTextColor(cr,cg,cb)
									else
										cellFrame.text:SetText("");
									end
								end,
			["rightclick"] = 	function()
									
									local x, y = GetCursorPosition()
									local uiScale = UIParent:GetEffectiveScale()
									
									EasyMenu(ageFilterMenu, YPFilterMenuFrame, getglobal("UIParent"), x/uiScale,y/uiScale, "MENU", 5)
								end
		}, -- [5]
		{ 
			["name"] = "chat message", 
			["width"] = 100, 
			["align"] = "LEFT",
			["bgcolor"] = colorDark,
			["tooltipText"] = "click to sort",
		}, -- [6]
	};
	

	local ChatMessageTypes = {
		["CHAT_MSG_SYSTEM"] = true,
		["CHAT_MSG_SAY"] = true,
		["CHAT_MSG_TEXT_EMOTE"] = true,
		["CHAT_MSG_YELL"] = true,
		["CHAT_MSG_WHISPER"] = true,
		["CHAT_MSG_PARTY"] = true,
		["CHAT_MSG_GUILD"] = true,
		["CHAT_MSG_OFFICER"] = true,
		["CHAT_MSG_CHANNEL"] = true,
		["CHAT_MSG_RAID"] = true,
	};


	
	local function OnResize()
		if st then
			columnHeaders[6].width =  frame:GetWidth() - 47 - 460
		
			local rows = floor((frame:GetHeight()-60-15) / 15)
		

			if rows >= #st.filtered then
				st.scrollframe:Show()
			else
				st.scrollframe:Hide()
			end


			st:SetDisplayCols(st.cols)
			st:SetDisplayRows(rows, st.rowHeight)
					
			st:Refresh()
		end
	end
	
	
	
	
	
	local function PlayerFunctionColor(player)
		if playerLocation[player] and not string.find(playerLocation[player], OFFLINE) then
--DEFAULT_CHAT_FRAME:AddMessage(playerLocation[player].." "..GetMinimapZoneText())
			if playerLocation[player] == GetMinimapZoneText() then
				return localColorTable
			end
			
			if guildList[player] then
				return guildColorTable
			end
			
			if friendList[player] then
				return friendColorTable
			end
			
			return onlineColorTable
		else
			return offlineColorTable
		end
	end
	
	
	local function PlayerFunctionLocation(player)
		return playerLocation[player] or "?"
	end
	
	local function LinkFunctionColor(tradeID, bitmap)
		if currentTradeskill then
			if (tradeID ~= currentTradeskill) then
				return noneSharedColorTable
			else
				if currentSingleTradeBitmap and TradeLink:BitsShared(currentSingleTradeBitmap, bitmap)~=0 then
					return singleSharedColorTable
				end
				
				if currentTradeBitmap and TradeLink:BitsShared(currentTradeBitmap, bitmap)==0 then
					return noneSharedColorTable
				end
			end
			
			return sharedColorTable
		end
		
		return sharedColorTable
	end
			
	
	
	--fnDoCellUpdate(rowFrame, cellFrame, st.data, st.cols, row, st.filtered[row], col, fShow);
	local function TimeDisplayFunction(rowFrame, cellFrame, data, cols, row, realrow, column, fShow, ...)
		if fShow then
			local cellData = data[realrow].cols[column];
			
			local elapsedTime = time() - cellData.value
			local formattedElapsedTime = SimpleTime(elapsedTime)
			
			if formattedElapsedTime == "" then
				formattedElapsedTime = "NEW"
			end

			cellFrame.text:SetText(formattedElapsedTime)
			
			local daysOld = (elapsedTime / (60*60*24))
			local cr = min(1,daysOld*.5+.5)
			local cg = min(1,1-min(math.pow(daysOld,2),1)*.8)
			local cb = max(0,min(1,daysOld*(1-daysOld)))*.8+.2
			
			cellFrame.text:SetTextColor(cr,cg,cb)
		else
			cellFrame.text:SetText("");
		end
		
		
	end
	
	
	local function BuildScrollingTable()
		if not st then 
			local rows = floor((frame:GetHeight() - 60) / 15)
			st = ScrollingTable:CreateST(columnHeaders,rows,nil,nil,frame);
			st.frame:SetPoint("BOTTOMLEFT",8,8)
			st.frame:SetPoint("TOP", frame, 0, -60)
			st.frame:SetPoint("RIGHT", frame, -8,0)
		end
		
		local data = {}
		local row = 1
	
		
-- GUILD CRAFT INTERFACE
	
		if GuildCraft then
			local guildLinks = GuildCraft.db.factionrealm.links
			
			for player, links in pairs(guildLinks) do
				guildCraftList[player] = ONLINE
				
				for trade, link in pairs(links) do
					
					if not data[row] then 
						data[row] = {};
					end
					
					
					
					local _,_,tradeID,level,bitmap  = string.find(link, "trade:(%d+):(%d+):%d+:[0-9a-fA-F]+:([<-{]+)|h")
					tradeID = tonumber(tradeID)

					local basicTrade = GetSpellInfo(basicTradeID[tradeID])
						
					local compressedBitmap = TradeLink:BitmapCompress(bitmap)
					
					data[row].cols = {
							{value=player, color=PlayerFunctionColor, colorargs={player}, tooltipText = "click to whisper player", onclickargs={player}},
							{value=PlayerFunctionLocation, args={player}, color=PlayerFunctionColor, colorargs={player}, onclickargs={player}, tooltipText = "click to refresh status"},
							{value=level},
							{value="["..basicTrade.."]", tradeID=basicTradeID[tradeID], onclickargs={link}, color=LinkFunctionColor, colorargs={basicTradeID[tradeID],compressedBitmap}, tooltipText="click to open link"},
							{value=time()},
							{value="guildcraft data"}
						}
						
					row = row + 1
				end
			end
		end
		
		

	
		for trade, adList in pairs(YPData[serverKey]) do
			for player, ad in pairs(adList) do
				if not guildCraftList[player] then
					if not data[row] then 
						data[row] = {};
					end
	--	"|cffffd000|Htrade:26790:375:375:544DE6:tz{zgfvUvy_cu{KtpwvUio]Wrs{c[ocGD><<Lt{Mx{Cm=<F<<\\A<B<D<<<<<<<<<<<<<<<|h[Tailoring]|h|r", -- [3] 
				
	--				local messageClean = string.gsub(ad.message, "|cffffd000|Htrade:[^|]+|h", "")
					
					
					local _,_,tradeID,level,bitmap  = string.find(ad.link, "trade:(%d+):(%d+):%d+:[0-9a-fA-F]+:([<-{]+)|h")
					tradeID = tonumber(tradeID)

					local basicTrade = GetSpellInfo(basicTradeID[tradeID])
						
					local compressedBitmap = TradeLink:BitmapCompress(bitmap)
					
--					local _,_,icon = GetSpellInfo(tradeID)

					local basicTrade = GetSpellInfo(basicTradeID[tradeID])
					
					data[row].cols = {
						{value=player, color=PlayerFunctionColor, colorargs={player}, tooltipText = "click to whisper player", onclickargs={player}},
						{value=PlayerFunctionLocation, args={player}, color=PlayerFunctionColor, colorargs={player}, onclickargs={player}, tooltipText = "click to refresh status"},
						{value=ad.level},
						{value="["..basicTrade.."]", tradeID=basicTradeID[tradeID], onclickargs={ad.link}, color=LinkFunctionColor, colorargs={basicTradeID[tradeID],compressedBitmap}, tooltipText="click to open link"},
						{value=ad.time},
						{value=ad.message}
					}
					
					row = row + 1
				end
			end 
		end
		

				
		st:SetData(data)
		
		
		st:RegisterEvents({
			["OnEnter"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, ...)
				rowFrame:SetHighLightColor(st.highlight);
				
				local cellData = data[realrow].cols[column]
				
				if cellData.tooltipText then
					GameTooltip:SetOwner(cellFrame, "ANCHOR_TOPLEFT")
	
					GameTooltip:ClearLines()

					GameTooltip:AddLine(cellData.tooltipText,1,1,1)
				
					GameTooltip:Show()
				end
			end,
			["OnLeave"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, ...)
				rowFrame:SetHighLightColor(highlightOff);
				
				GameTooltip:Hide()
			end,
			["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, button, ...)

				local cellData = data[realrow].cols[column]
				
				if cellData.onclick then
					cellData.onclick(button, unpack(cellData.onclickargs or {}))
				else
					if cols[column].onclick then
						cols[column].onclick(button, unpack(cellData.onclickargs or cols[column].onclickargs or {}))
					end
				end
			end,
		});
		
		
		OnResize()
		
		st:SetFilter(function(self, row)
			if selectedTradeskill and (row.cols[4].tradeID ~= selectedTradeskill) then
				return false
			end
			
			if selectedAge and ((time() - row.cols[5].value)/(60*60*24) > selectedAge) then
				return false
			end
			
			if not selectedPlayers["OFFLINE"] then
				if not playerLocation[row.cols[1].value] or string.find(playerLocation[row.cols[1].value],OFFLINE) then
					return false
				end
			end
			
			if not selectedPlayers["STRANGERS"] then
				if not guildList[row.cols[1].value] and not friendList[row.cols[1].value] then
					return false
				end
			end
			
			if selectedLevel and row.cols[3].value < selectedLevel then
				return false
			end
			
			return true
		end)
	end
	
	
	local function CloseFrame()
		frame:Hide()
	end
	
	
	local function ToggleFrame()
		if frame:IsVisible() then
			frame:Hide()
		else
			BuildScrollingTable()
			frame:Show()
		end
	end

	

	local function GetSizingPoint(frame)
		local x,y = GetCursorPosition()
		local s = frame:GetEffectiveScale()
		
		local left,bottom,width,height = frame:GetRect()
		
		x = x/s - left
		y = y/s - bottom
		
		if x < 10 then
			if y < 10 then return "BOTTOMLEFT" end
			
			if y > height-10 then return "TOPLEFT" end
			
			return "LEFT"
		end
		
		if x > width-10 then
			if y < 10 then return "BOTTOMRIGHT" end
			
			if y > height-10 then return "TOPRIGHT" end
			
			return "RIGHT"
		end
		
		if y < 10 then return "BOTTOM" end
		
		if y > height-10 then return "TOP" end
		
		return "UNKNOWN"
	end


	function CreateResizableWindow(windowTitle, width, height, resizeFunction)
		local testFrame = CreateFrame("Frame","TestFrame",UIParent)
		testFrame:SetPoint("CENTER",0,0)
		
		frame = CreateFrame("Frame",nil,UIParent)
		frame:Hide()
		
		frame:SetFrameStrata("DIALOG")
		frame:SetWidth(width)
		frame:SetHeight(height)


		frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
												edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", 
												tile = true, tileSize = 32, edgeSize = 32, 
												insets = { left = 8, right = 8, top = 8, bottom = 8 }})

		
		
		frame:SetResizable(true)
		frame:SetMovable(true)

		frame:SetPoint("CENTER",0,0)

		
		frame:SetScript("OnSizeChanged", function() resizeFunction() end)
		
		
		
		frame:EnableMouse(true)
		
		frame:SetScript("OnMouseDown", function() frame:StartSizing(GetSizingPoint(frame)) end)
		frame:SetScript("OnMouseUp", frame.StopMovingOrSizing)
		frame:SetScript("OnHide", frame.StopMovingOrSizing)
		
		
		local mover = CreateFrame("Frame",nil,frame)
		mover:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,0)
		mover:SetPoint("TOPLEFT",frame,"TOPLEFT",0,0)
		
		mover:EnableMouse(true)
		
		mover:SetScript("OnMouseDown", function() frame:StartMoving("TestFrame") end)
		mover:SetScript("OnMouseUp", function() frame:StopMovingOrSizing("TestFrame") end)
		mover:SetScript("OnHide", function() frame:StopMovingOrSizing() end)

		
		mover:SetHitRectInsets(10,10,10,10)
		
		frame.mover = mover
		
		
		local title = CreateFrame("Frame",nil,frame)


		title:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
												tile = true, tileSize = 16, edgeSize = 16, 
												insets = { left = 4, right = 4, top = 4, bottom = 4 }})

		title:SetHeight(30)
		
		title.texture = title:CreateTexture()
		title.texture:SetPoint("BOTTOMLEFT",title,"BOTTOMLEFT",4,4)
		title.texture:SetPoint("TOPRIGHT",title,"TOPRIGHT",-4,-4)
		
		title.texture:SetTexture("Interface\\AddOns\\GnomishYellowPages\\Art\\headerbackground.tga")
		title.texture:SetGradient("vertical",.66,.54,0,.6,.48,0)
		
		title:SetPoint("CENTER",frame,"TOP",0,-6)

		title:EnableMouse(true)
		
		title:SetScript("OnMouseDown", function() frame:StartMoving() end)
		title:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)
		title:SetScript("OnHide", function() frame:StopMovingOrSizing() end)
		
		
		
		local text = title:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		text:SetJustifyH("CENTER") 
		text:SetPoint("CENTER",0,0)
		text:SetTextColor(1,1,1)
		text:SetText(windowTitle)
		
		title:SetWidth(text:GetStringWidth()+50)
		

		
		frame.title = title
		

		
		local x = frame:CreateTexture()
		
		x:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-4,-4)
		x:SetTexture("Interface/DialogFrame/UI-DialogBox-Corner")
		x:SetWidth(32)
		x:SetHeight(32)
		
		
		local closeButton = CreateFrame("Button",nil,frame,"UIPanelCloseButton")
		closeButton:SetPoint("TOPRIGHT",0,0)
		closeButton:SetScript("OnClick", function() frame:Hide() end)
		closeButton:SetFrameLevel(closeButton:GetFrameLevel()+5)
		
		return frame
	end
	
	
	local bid = 1
	function CreateToggle(parent, text, value, callback)
		local toggleButton = CreateFrame("CheckButton", "CheckButtonID"..bid, parent, "UICheckButtonTemplate")
		toggleButton.text = getglobal("CheckButtonID"..bid.."Text")
		
		bid = bid + 1
		toggleButton:SetHeight(24)
		toggleButton:SetWidth(24)
		
		toggleButton.text:SetText(text)
		
		if value then
			toggleButton:SetChecked(true)
		end
		
		toggleButton.value = value
		
		
		toggleButton:SetScript("OnClick", function(self)
			self.value = self:GetChecked()
			
			local kids = { toggleButton:GetChildren() }

			for _, child in ipairs(kids) do
				if self.value then
				 	child:Show()
				else
					child:Hide()
				end
			end
			
			if callback then
				callback()
			end
		end)
		
		return toggleButton
	end
	
	
	function CreateSlider(parent, text, min, max, value, units, callback)
		local slider = CreateFrame("Slider", "SliderID"..bid, parent, "OptionsSliderTemplate")
		slider.text = getglobal("SliderID"..bid.."Text")
		slider.textLow = getglobal("SliderID"..bid.."Low")
		slider.textHigh = getglobal("SliderID"..bid.."High")
		bid = bid + 1
		
		slider.text:SetText(text)
		slider.textLow:SetText(min)
		slider.textHigh:SetText(max)
		
		slider:SetPoint("TOPLEFT", parent, "TOPLEFT", 0, -30)
		slider:SetWidth(200)
		slider:SetHeight(17)
		
		
		slider:SetMinMaxValues(min,max)
		slider:SetValueStep(1)
		slider:SetValue(value)
		
		slider.tooltipText = value.." "..units
		slider.value = value
		
		
		slider:SetScript("OnValueChanged", function(self, value)
			self.tooltipText = value.." "..units
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1);
			self.value = value
			
			if callback then
				callback()
			end
		end)
		
		return slider
	end
	

	local function AddToPlayerList(player, age, location)
		if not playerLocation[player] then
			table.insert(playerList, player)
			
			playerLocation[player] = location
			playerAge[player] = age
		end
	end
	
	-- sample link
	-- "|cffffd000|Htrade:26790:375:375:544DE6:tz{zgfvUvy_cu{KtpwvUio]Wrs{c[ocGD><<Lt{Mx{Cm=<F<<\\A<B<D<<<<<<<<<<<<<<<|h[Tailoring]|h|r", -- [3] 


	local function SaveAdvertisement(message, player)
		
		local tradeData = YPData[serverKey]
		
		
		for link in string.gmatch(message, "|c%x+|Htrade:%d+:%d+:%d+:[0-9a-fA-F]+:[<-{]+|h%[[%a%s]+%]|h|r") do
			if link then
				local profession,level,playerID,tradeName = string.match(link,"|c%x+|Htrade:(%d+):(%d+):%d+:([0-9a-fA-F]+):[<-{]+|h%[([%a%s]+)%]|h|r")
		
--[[
	TODO:
	
	options here would be to black list players or professions and to have a level requirement (like say 250+)
	
	this would help cut down on data overload
]]
			
							
				if not tradeData[tradeName] then
					tradeData[tradeName] = {}
				end
				
				tradeData[tradeName][player] = { ["message"] = message, ["time"] = time(), ["link"] = link, ["level"] = tonumber(level)}
				
				AddToPlayerList(player, 0, ONLINE)
			end
		end
		
		if frame:IsVisible() then
			BuildScrollingTable()
		end
	end

	
	local function ChatMessage(message, player)
		if string.find(message, "|Htrade:") then
			SaveAdvertisement(message, player)
		end
	end
	
	
	local function UpdateWhoData()
		local numWhos, totalCount = GetNumWhoResults()
		
		local tradeData = YPData[serverKey]
		
		playerLocation[playerWhoPending] = OFFLINE
		
		for i=1,numWhos do
			local charname, guildname, level, race, class, zone, classFileName = GetWhoInfo(i)		
			if charname == playerWhoPending then
				playerWhoPending = ""
			end
			
			if playerLocation[charname] then
				playerLocation[charname] = zone
			end
		end
		
		if st then
			st:SortData()
			st:Refresh()
		end
		
		whoDataPending = false
		SetWhoToUI(0)
	end
	

	local function InitplayerLocation()
		for trade,data in pairs(YPData[serverKey]) do
			for player,ad in pairs(data) do
				AddToPlayerList(player, time() - ad.time, OFFLINE)
			end
		end			

		
		table.sort(playerList, function(a,b) return (playerAge[a] or 0)<(playerAge[b] or 0) end)
	end

	
	local function EventHandler(this, event)
		if ChatMessageTypes[event] then	
			ChatMessage(arg1, arg2)
		end
		
	end
	
	
	local function CreateTimer(name, countDown, triggerFunction, repeatTime)
		timerList[name] = {countDown=countDown, triggerFunction=triggerFunction, repeatTime=repeatTime}
	end
	
	
	local function DeleteTimer(name)
		timerList[name] = nil
	end
	
	local thisTime
	local lastTime
	
	local function UpdateHandler(this, event)
		thisTime = time()
		local elapsed = thisTime - (lastTime or thisTime)
		
		for name,timer in pairs(timerList) do
			timer.countDown = timer.countDown - elapsed
			if timer.countDown <= 0 then
				timer:triggerFunction(timer)
				
				if timer.repeatTime then
					timer.countDown = timer.countDown + timer.repeatTime
				else
					timer = nil
				end
			end
		end
		
		lastTime = thisTime
	end
	
	
	local classList = { "Druid", "Mage", "Hunter", "Warlock", "Warrior", "Paladin", "Priest", "Rogue", "Shaman", "Death Knight"}
	
	local currentWhoClass = 1
	
	local function WhoUpdateClass(timer)
		if not WhoFrame:IsVisible() then
			SetWhoToUI(1)
			SendWho("c-"..classList[currentWhoClass])
			
			currentWhoClass = currentWhoClass + 1
			
			if currentWhoClass > #classList then
				currentWhoClass = 1
			end
		end
	end
	
	
	
	local previousIndex = 0
	local whoIteration = 0
	local function WhoUpdate(timer)
		if #playerList < 1 then return end
		
		if not WhoFrame:IsVisible() then
			playerWhoPending = ""
			
			whoIteration = whoIteration + 1
			
			local index = previousIndex + 1
			
			if index > #playerList then
				index = 1
			end
			
			previousIndex = index
			
			if not friendList[playerList[index]] and not guildList[playerList[index]] then
				whoDataPending = true
				SetWhoToUI(1)
				SendWho("n-"..playerList[index])
				playerWhoPending = playerList[index]
			else
				timer.countDown = 1 - timer.repeatTime			-- hack to try again in 1 second since this player is not interesting to us
			end
		end
	end
	
	
	local function FriendUpdate(timer)
		for i=1,GetNumFriends() do
			local name, level, class, area, connected, status, note = GetFriendInfo(i)
			
			if connected then
				playerLocation[name] = area
			else
				playerLocation[name] = OFFLINE
			end
			
			friendList[name] = true
		end
	end
	
	
	local function GuildRosterUpdate()
		local members = GetNumGuildMembers(true)
		
		for i=1,members do
			local name, _, _, _, _, zone, _, _, online, status = GetGuildRosterInfo(i)
			
			if online then
				playerLocation[name] = zone
			else
				local yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i)
				local lastOn
				
				if yearsOffline == 0 and monthsOffline == 0 then
					if daysOffline > 0 then
						lastOn = (math.floor((daysOffline + hoursOffline/24)*10+5)/10).." days"
					else
						if hoursOffline == 0 then
							lastOn = "not long"
						else
							lastOn = (math.floor(hoursOffline*10+5)/10).." hours"
						end
					end
				else
					lastOn = "ages"
				end

				playerLocation[name] = OFFLINE .. " ("..lastOn..")"
			end
			
			guildList[name] = true
		end
		
		guildDataPending = false
	end
	
	
	local function GuildUpdate(timer)
		if IsInGuild() and not GuildFrame:IsVisible() then
			if not GetGuildRosterShowOffline() then
				SetGuildRosterShowOffline(true)
			else
				GuildRoster()
			end
			
			guildDataPending = true
		end
	end
	
	
	local function TradeSkillUpdate()
		local lib = LibStub("LibTradeLinks-1.0")
		local spells = {}
		
		for i=1,GetNumTradeSkills() do
		
			local found,_,recipeID = string.find(GetTradeSkillRecipeLink(i) or "","enchant:(%d+)")
			
			if found then
				spells[tonumber(recipeID)] = true
			end
		end

		currentTradeskill = tradeIDbyName[GetTradeSkillLine()]

		local _,_,tradeID,level,bitmap = string.find(lib:Encode(libTLIDbyTradeID[currentTradeskill], spells),"trade:(%d+):(%d+):%d+:[0-9a-fA-F]+:([<-{]+)|h")
	
		currentTradeBitmap = TradeLink:BitmapCompress(bitmap)
--DEFAULT_CHAT_FRAME:AddMessage("current bitmap: "..bitmap)	

		if st then
			st:SortData()
			st:Refresh()
		end
	end
	
	
	local function TradeSkillClose()
		currentTradeskill = nil
		currentTradeBitmap = nil
		currentSingleTradeBitmap = nil
		
		if st then
			st:SortData()
			st:Refresh()
		end
	end
	
	local function OnLoad()
		if not Config then
			Config = { ["WhoUpdate"] = true, ["WhoFrequency"] = 10 } 
		end
		
		if not YPData then YPData = {} end
		if not YPData[serverKey] then YPData[serverKey] = {} end
		
		InitplayerLocation()
	
		frame = CreateResizableWindow("Gnomish Yellow Pages v"..MAJOR_VERSION.." (rev"..MINOR_VERSION..")", 700, 400, OnResize)
			
		frame:SetMinResize(700,200)
		
			
		for v in pairs(ChatMessageTypes) do
			frame:RegisterEvent(v)
		end
		
	
		frame:SetUserPlaced(true)
		
		frame:SetScript("OnEvent", EventHandler)
		
		SLASH_GNOMISHYELLOWPAGES1 = "/gnomishyellowpages"
		SLASH_GNOMISHYELLOWPAGES2 = "/GYP"
		SLASH_GNOMISHYELLOWPAGES3 = "/yp"
		SLASH_GNOMISHYELLOWPAGES4 = "/yellowpages"
		SlashCmdList["GNOMISHYELLOWPAGES"] = function() ToggleFrame() end
		
		local oldClose = CloseSpecialWindows
		
		CloseSpecialWindows = function()
			if not frame:IsVisible() then
				return oldClose()
			else
				frame:Hide()
				return 1
			end
		end
		
			
	
		local original_FriendsFrame_OnEvent = FriendsFrame_OnEvent
		
		local function my_FriendsFrame_OnEvent(...)
			if event == "WHO_LIST_UPDATE" then
				if not whoDataPending or WhoFrame:IsVisible() then
					original_FriendsFrame_OnEvent(...)
				end
			elseif event == "GUILD_ROSTER_UPDATE" then
				if not guildDataPending or GuildFrame:IsVisible() then
					original_FriendsFrame_OnEvent(...)
				end
			else
				original_FriendsFrame_OnEvent(...)
			end
		end

		FriendsFrame_OnEvent = my_FriendsFrame_OnEvent

		
		local original_SelectTradeSkill = SelectTradeSkill
		
		function SelectTradeSkill(index)
--DEFAULT_CHAT_FRAME:AddMessage("trade index "..index)
			if index then
				local lib = LibStub("LibTradeLinks-1.0")
				local spells = {}
			
				local found,_,recipeID = string.find(GetTradeSkillRecipeLink(index) or "","enchant:(%d+)")
					
				if found then
					spells[tonumber(recipeID)] = true
				end
			
				currentTradeskill = tradeIDbyName[GetTradeSkillLine()]

				local _,_,tradeID,level,bitmap = string.find(lib:Encode(libTLIDbyTradeID[currentTradeskill], spells),"trade:(%d+):(%d+):%d+:[0-9a-fA-F]+:([<-{]+)|h")
			
				currentSingleTradeBitmap = TradeLink:BitmapCompress(bitmap)
			else
				currentSingleTradeBitmap = nil
			end
			
			if st then
				st:SortData()
				st:Refresh()
			end
		
			original_SelectTradeSkill(index)
		end
		
		LoadAddOn("Skillet")
		
		if Skillet then
--DEFAULT_CHAT_FRAME:AddMessage("Skillet Setup")
			local original_SkilletSetSelectedSkill = Skillet.SetSelectedSkill
			
			function Skillet:SetSelectedSkill(skillIndex, wasClicked)
				if skillIndex then
					SelectTradeSkill(skillIndex)
				end
				
				original_SkilletSetSelectedSkill(Skillet,skillIndex, wasClicked)
			end
		end
		
		
		
		local optionsPanel = CreateFrame( "Frame", "GYPConfigPanel", UIParent );
		
		optionsPanel.name  = "Gnomish Yellow Pages"
		optionsPanel.okay = function(self) end
		optionsPanel.cancel = function(self) end
		
		InterfaceOptions_AddCategory(optionsPanel);

		local function WhoTimerAdjustment()
			Config["WhoUpdate"] = whoAutoUpdateToggle.value
			Config["WhoFrequency"] = whoAutoUpdateFrequency.value
			
			if whoAutoUpdateToggle.value then 
				CreateTimer("whoUpdater", whoAutoUpdateFrequency.value, WhoUpdate, whoAutoUpdateFrequency.value)
			else
				DeleteTimer("whoUpdater")
			end
		end
		
		whoAutoUpdateToggle = CreateToggle(optionsPanel, "Auto Update Stranger Locations", Config["WhoUpdate"], WhoTimerAdjustment)
		whoAutoUpdateFrequency = CreateSlider(whoAutoUpdateToggle, "Frequency for Update", 10, 60, Config["WhoFrequency"], "seconds", WhoTimerAdjustment)
	
		whoAutoUpdateToggle:SetPoint("TOPLEFT", 50,-50)
		
		
		WhoTimerAdjustment()

		
		CreateTimer("friendUpdater", 15, FriendUpdate, 60)
		CreateTimer("guildUpdater", 5, GuildUpdate, 60)
		
	--[[
		OrigWhoList_Update = WhoList_Update;
	
		function WhoList_Update()
			if WhoFrame:IsVisible() or not whoDataPending then
				OrigWhoList_Update();
			end
		end


		OrigGuildStatus_Update = GuildStatus_Update;
		
		function GuildStatus_Update()
			if GuildFrame:IsVisible() or not guildDataPending then
				OrigGuildStatus_Update();
			end
		end
	]]
	
	
	end
	
	
	local master = CreateFrame("Frame")
	
	master:RegisterEvent("WHO_LIST_UPDATE")
	master:RegisterEvent("GUILD_ROSTER_UPDATE")
	master:RegisterEvent("TRADE_SKILL_CLOSE")
	master:RegisterEvent("TRADE_SKILL_UPDATE")
	master:RegisterEvent("ADDON_LOADED")
	
	master:SetScript("OnEvent",function(f, event, arg1)
		if event == "ADDON_LOADED" then
			if arg1 == "GnomishYellowPages" then
				OnLoad()
			end
		end
		
		if event == "WHO_LIST_UPDATE" then
			UpdateWhoData()
		end
		
		if event == "GUILD_ROSTER_UPDATE" then
			GuildRosterUpdate()
		end
		
		if event == "TRADE_SKILL_UPDATE" then
			TradeSkillUpdate()
		end
		
		if event == "TRADE_SKILL_CLOSE" then
			TradeSkillClose()
		end
	end)
	


	master:SetScript("OnUpdate", UpdateHandler)
end





